/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.stimmzettel.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.stimmzettel.entity.Stimmzettel;
import de.ivu.elect.business.stimmzettel.entity.StimmzettelUK;

public abstract class AbstractStimmzettelDAO extends de.ivu.elect.jee.entity.AbstractDAO<Stimmzettel,
        de.ivu.elect.business.stimmzettel.entity.StimmzettelPK
    , StimmzettelUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractStimmzettelDAO.class);

  public AbstractStimmzettelDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.stimmzettel.entity.StimmzettelPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Stimmzettel findByPrimaryKey(
        de.ivu.elect.business.stimmzettel.entity.StimmzettelPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Stimmzettel findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Stimmzettel.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: ByGebietAndStimmzettelteamNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: DELETE FROM Stimmzettel o WHERE o.gebiet = ?1 AND o.stimmzettelTeam = ?2<br>
      * SQL: <br>
      */
     public Integer deleteByGebietAndStimmzettelteam( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam stimmzettelTeam) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam stimmzettelTeamCheckedAndAttached =  checkAndAttach(stimmzettelTeam, de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam.class, "stimmzettelTeam"); ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("STIMMZETTEL.ByGebietAndStimmzettelteam")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, stimmzettelTeamCheckedAndAttached)
                                                                                .executeUpdate();
          
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmzettel, deleteByGebietAndStimmzettelteam - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", stimmzettelTeam:'"+stimmzettelTeam+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".deleteByGebietAndStimmzettelteam(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ByGebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: DELETE FROM Stimmzettel o WHERE o.gebiet = ?1<br>
      * SQL: <br>
      */
     public Integer deleteByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("STIMMZETTEL.ByGebiet")
                              .setParameter(1, gebietCheckedAndAttached)
                                                                                .executeUpdate();
          
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmzettel, deleteByGebiet - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".deleteByGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountGebietAndStimmzettelteamNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(o) FROM Stimmzettel o WHERE o.gebiet=?1 AND o.stimmzettelTeam = ?2<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountGebietAndStimmzettelteam( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam stimmzettelTeam) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam stimmzettelTeamCheckedAndAttached =  checkAndAttach(stimmzettelTeam, de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam.class, "stimmzettelTeam"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("STIMMZETTEL.CountGebietAndStimmzettelteam")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, stimmzettelTeamCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountGebietAndStimmzettelteam - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmzettel, findByCountGebietAndStimmzettelteam - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", stimmzettelTeam:'"+stimmzettelTeam+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountGebietAndStimmzettelteam(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebietAndStimmzettelteamNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmzettel o WHERE o.gebiet=?1 AND o.stimmzettelTeam = ?2<br>
      * SQL: <br>
      */
     public java.util.List<Stimmzettel> findByGebietAndStimmzettelteam( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam stimmzettelTeam) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam stimmzettelTeamCheckedAndAttached =  checkAndAttach(stimmzettelTeam, de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam.class, "stimmzettelTeam"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMZETTEL.GebietAndStimmzettelteam")
                              .setParameter(1, gebietCheckedAndAttached)
                                        .setParameter(2, stimmzettelTeamCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebietAndStimmzettelteam - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmzettel, findByGebietAndStimmzettelteam - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
           + ", stimmzettelTeam:'"+stimmzettelTeam+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebietAndStimmzettelteam(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebietCountNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(o) FROM Stimmzettel o WHERE o.gebiet=?1<br>
      * SQL: <br>
      */
     public java.lang.Long findByGebietCount( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("STIMMZETTEL.GebietCount")
                              .setParameter(1, gebietCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebietCount - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmzettel, findByGebietCount - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebietCount(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmzettel o WHERE o.gebiet=?1<br>
      * SQL: <br>
      */
     public java.util.List<Stimmzettel> findByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMZETTEL.Gebiet")
                              .setParameter(1, gebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmzettel, findByGebiet - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmzettel o WHERE o.gebiet.wahl=?1<br>
      * SQL: <br>
      */
     public java.util.List<Stimmzettel> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMZETTEL.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmzettel, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.stimmzettel.entity.StimmzettelUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.stimmzettel.entity.StimmzettelUK uk,
        de.ivu.elect.business.stimmzettel.entity.StimmzettelPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.stimmzettel.entity.Stimmzettel findByUK(de.ivu.elect.business.stimmzettel.entity.StimmzettelUK uk){

    try {
     return (de.ivu.elect.business.stimmzettel.entity.Stimmzettel) getEntityManager().createNamedQuery("STIMMZETTEL.UK")
                  .setParameter(1, uk
                .getNummer ()  
              )
             .setParameter(2, uk
                .getGebietUK ()  
                .getNummer ()  
              )
             .setParameter(3, uk
                .getGebietUK ()  
                .getGebietsartUK ()  
                .getName ()  
              )
             .setParameter(4, uk
                .getGebietUK ()  
                .getGebietsartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(5, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getName ()  
              )
             .setParameter(6, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(7, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(8, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(9, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(10, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(11, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(12, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("Stimmzettel, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}